using System;
using System.Runtime.InteropServices;
namespace LEAPI
{
    public class LALanio
    {
        //***************************************************************************
        //* ^`A萔`
        //***************************************************************************

        //***************************************************************************
        //* LALanioGetLastErrorԂG[R[h
        //***************************************************************************
        public enum LANIOERROR : int
        {
            LELANIOERR_NOINIT = 1,          //* Ă܂BLALanioInitsĂB
            LELANIOERR_NOLANIO,             //* ʁALANIOł܂łB
            LELANIOERR_NOTEXIST,            //* ŔLANIO葽lw肵܂B
            LELANIOERR_NOTFOUND,            //* w肳ꂽLANIO𔭌ł܂łB
            LELANIOERR_NOCONNECTED,         //* LANIOƐڑĂ܂BLALanioConnectsĂB
            LELANIOERR_INVALIDOPERATION,    //* w肳ꂽ͎sł܂B
            LELANIOERR_ALREADY_CONNECTED,   //* łɐڑĂ܂B
            LELANIOERR_OVERCONNECTMAX,      //* ڑő吔𒴉߂܂B
            LELANIOERR_INVALIDRETURNVALUE,  //* sȖ߂lԂ܂B
        }
        //***************************************************************************
        //* LALanioGetModelŎ擾LANIOf
        //***************************************************************************
        public enum LANIOMODEL : int
        {
            NOTLANIO = 0,
            LA2R3A = 8,
            LA2A3P = 9,
            NO_GETMODEL = -1,
        };
        //***************************************************************************
        //* ݒ萔
        //***************************************************************************
        public enum LANIO_AI_RANGE : int
        {
            LALANIO_AI_RANGE_100mV = 0,
            LALANIO_AI_RANGE_1V = 1,
            LALANIO_AI_RANGE_10V = 2,
            LALANIO_AI_RANGE_30V = 3,
            LALANIO_AI_RANGE_20mA_250orm = 4,
            LALANIO_AI_RANGE_20mA_50orm = 5,
        };
        public enum LALANIO_AI_TRANSMITCYCLE : int
        {
            LALANIO_AI_TRANSMITCYCLE_0_05sec = 0,
            LALANIO_AI_TRANSMITCYCLE_0_1sec = 1,
            LALANIO_AI_TRANSMITCYCLE_0_2sec = 2,
            LALANIO_AI_TRANSMITCYCLE_0_5sec = 3,
            LALANIO_AI_TRANSMITCYCLE_1sec = 4,
            LALANIO_AI_TRANSMITCYCLE_2sec = 5,
            LALANIO_AI_TRANSMITCYCLE_5sec = 6,
            LALANIO_AI_TRANSMITCYCLE_10sec = 7,
            LALANIO_AI_TRANSMITCYCLE_20sec = 8,
            LALANIO_AI_TRANSMITCYCLE_30sec = 9,
            LALANIO_AI_TRANSMITCYCLE_1min = 10,
            LALANIO_AI_TRANSMITCYCLE_2min = 11,
            LALANIO_AI_TRANSMITCYCLE_5min = 12,
            LALANIO_AI_TRANSMITCYCLE_10min = 13,
        };
        public enum LALANIO_AO_RANGE : int
        {
            LALANIO_AO_RANGE_10V = 0,
            LALANIO_AO_RANGE_20mA = 1,
        };

        //***************************************************************************
        //* AIAG[擾֐
        //***************************************************************************

        //***************************************************************************
        //*     LANIOCu܂B
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioInit")]
        public static extern int Init();

        //***************************************************************************
        //*     LANIOCu̎gpI܂B
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioEnd")]
        public static extern int End();

        //***************************************************************************
        //*     OɔG[ԍ擾܂B
        //*     ߂l : G[̏Ԃ܂
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetLastError")]
        public static extern int GetLastError();

        //***************************************************************************
        //* LANIO֐
        //***************************************************************************

        //***************************************************************************
        //*     ILANIOIDModel擾@\ɂĂ̐ݒ܂B
        //*        : enable  ̋@\gpꍇTRUE(1)AȂꍇFALSE(0)
        //*              port    IDModel擾VÃ|[gԍ
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioSetAutoRequestIdModel")]
        public static extern int SetAutoRequestIdModel(int enable, int port);

        //***************************************************************************
        //*     LANɂLANIO܂B
        //*        : msec    ^CAEgԁiP mbj
        //*     ߂l : LANIO̐BłȂꍇ0BG[-1
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioSearch")]
        public static extern int Search(int msec);

        //***************************************************************************
        //* LANIO擾֐
        //***************************************************************************

        //***************************************************************************
        //*     LANIOIPAhX擾܂B
        //*        : lanio       LANIOԍ
        //*              ipaddress   IPAhX擾obt@ւ̎Q(16byteKv)
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetIpAddress")]
        public static extern int GetIpAddress(int lanio, System.Text.StringBuilder ipaddress);

        //***************************************************************************
        //*     LANIOMACAhX擾܂B
        //*        : lanio       LANIOԍ
        //*              macaddress  MACAhX擾obt@ւ̎Q(6byteKv)
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetMacAddress")]
        public static extern int GetMacAddress(int lanio, byte[] macaddress);

        //***************************************************************************
        //*     LANIOIDԍ擾܂B
        //*        : lanio   LANIOԍ
        //*              id      LANIOID擾obt@ւ̎Q
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetId")]
        public static extern int GetId(int lanio, ref int id);

        //***************************************************************************
        //*     LANIÕf擾܂B
        //*        : lanio   LANIOԍ
        //*              model   LANIÕf擾obt@ւ̎Q
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetModel")]
        public static extern int GetModel(int lanio, ref int model);

        //***************************************************************************
        //*     LANIOɑ΂IDƃfԍ₵܂B
        //*        : lanio   LANIOԍ
        //*              id      LANIOID擾obt@ւ̎Q
        //*              model   LANIÕf擾obt@ւ̎Q
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioRequestIdModel")]
        public static extern int RequestIdModel(int lanio, ref int id, ref int model);

        //***************************************************************************
        //* LANIOڑ֐
        //***************************************************************************

        //***************************************************************************
        //*     LALanioSearchɂĔꂽԂw肵Đڑ܂B
        //*        : lanio   LANIOԍ
        //*     ߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioConnect")]
        public static extern int Connect(int lanio);

        //***************************************************************************
        //*     IDƃfw肵Đڑ܂B
        //*        : id      LANIOIDԍ
        //*              model   LANIÕf
        //*     ߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioConnectByIdModel")]
        public static extern int ConnectByIdModel(int id, int model);

        //***************************************************************************
        //*     IPAhXw肵Đڑ܂B
        //*        : ipaddress   IPAhX
        //*     ߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioConnectByIpAddress")]
        public static extern int ConnectByIpAddress(string ipaddress);

        //***************************************************************************
        //*     MACAhXw肵Đڑ܂B
        //*        : macaddress  MACAhXobt@ւ̎Q
        //*     ߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioConnectByMacAddress")]
        public static extern int ConnectByMacAddress(byte[] macaddress);

        //***************************************************************************
        //*     IPAhXURLw肵Đڑ܂B
        //*        : address IPAhX܂urlobt@ւ̎Q
        //*              msec    ^CAEgԁiP mbj
        //*     ߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioConnectDirect")]
        public static extern int ConnectDirect(string address, int msec);

        //***************************************************************************
        //* LANIOؒf֐
        //***************************************************************************

        //***************************************************************************
        //*     LANIOƂ̐ڑؒf܂B
        //*        : handle  LANIOnh
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioClose")]
        public static extern int Close(int handle);

        //***************************************************************************
        //* o͊֐
        //***************************************************************************

        //***************************************************************************
        //*     LANIODO𑀍삵܂BSĂDOɑ΂Ăɑ삷鎞Ɏgp܂B
        //*        : handle  LANIOnh
        //*              signal  DO|[g̐ݒBŉʃrbgDO1ADO2...ɑΉ܂
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioDO")]
        public static extern int DO(int handle, int signal);

        //***************************************************************************
        //*     LANIǑ݂DOԂ擾܂BSĂDOɑ΂ĂɎ擾鎞Ɏgp܂B
        //*        : handle  LANIOnh
        //*              signal  DO|[g̓eobt@ւ̎Q
        //*                      ŉʃrbgDO1ADO2...
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetDO")]
        public static extern int GetDO(int handle, ref int signal);

        //***************************************************************************
        //*     LANIODI擾܂BSĂDIɑ΂ĂɎ擾鎞Ɏgp܂B
        //*        : handle  LANIOnh
        //*              signal  DI|[g̓eobt@ւ̎Q
        //*                      ŉʃrbgDI1ADI2...
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioDI")]
        public static extern int DI(int handle, ref int signal);

        //***************************************************************************
        //*     LANIOAOdo͂܂
        //*        : handle  LANIOnh
        //*              ch      `lw肵܂B 0:AO1 1:AO2 ...
        //*              val     o͒lw肵܂B
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioAOVoltage")]
        public static extern int AOVoltage(int handle, int ch, int val);

        //***************************************************************************
        //*     LANIOAOdo͂܂
        //*        : handle  LANIOnh
        //*              ch      `lw肵܂B 0:AO1 1:AO2 ...
        //*              val     o͒lw肵܂B
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioAOAmpere")]
        public static extern int AOAmpere(int handle, int ch, int val);

        //***************************************************************************
        //*     LANIOAOdo͂܂
        //*        : handle  LANIOnh
        //*              ch_count o͂`lw肵܂
        //*              ch       o͂`lzw肵܂ 0:AO1 1:AO2 ...
        //*              range    o͂d/dzw肵܂ 0:d 1:d
        //*              val      o͒lw肵܂B
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioAOMulti")]
        public static extern int AOMulti(int handle, int ch_count,
                IntPtr ch, IntPtr range, IntPtr val);

        //***************************************************************************
        //*     LANIOAȌlݒ肵܂
        //*        : handle  LANIOnh
        //*              ch      `lw肵܂B 0:AO1 1:AO2 ...
        //*              range   d/dw肵܂ 0:d 1:d
        //*              val     o͒lw肵܂B
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioSetInitialAO")]
        public static extern int SetInitialAO(int handle, int ch, int range, int val);

        //***************************************************************************
        //*     LANIOAȌo͒l擾܂
        //*        : handle  LANIOnh
        //*              ch      `lw肵܂B 0:AO1 1:AO2 ...
        //*              range   d/dobt@ւ̃|C^ 0:d 1:d
        //*              val     o͒lobt@ւ̃|C^
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetAO")]
        public static extern int GetAO(int handle, int ch, ref int range, ref int val);

        //***************************************************************************
        //*     LANIOAI͂܂
        //*        : handle  LANIOnh
        //*              ch      `lw肵܂B 0:AI1 1:AI2 ...
        //*              val     ͒lobt@ւ̃|C^
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioAI")]
        public static extern int AI(int handle, int ch, ref int val);

        //***************************************************************************
        //*     LANIOAIS`l͂܂
        //*        : handle  LANIOnh
        //*              val     ͒lobt@ւ̃|C^
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioAIAll")]
        public static extern int AIAll(int handle, IntPtr val);

        //***************************************************************************
        //*     LANIOAI̐ݒ擾܂
        //*        : handle        LANIOnh
        //*              ch            `lw肵܂B 0:AI1 1:AI2 ...
        //*              range         Wݒ肪obt@ւ̃|C^
        //*                            0:100mV  1:1V  2:10V  3:30V  4:20mA(250)  5:20mA(50)
        //*              transmitcycle ]TCNobt@ւ̃|C^ 
        //*                            0:0.05sec  1:0.1sec  2:0.2sec  3:0.5sec
        //*                            4:1sec  5:2sec  6:5sec  7:10sec  8:20sec  9:30sec
        //*                            10:1min  11:2min  12:5min  13:10min
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetAISetting")]
        public static extern int GetAISetting(int handle, int ch, ref int range, ref int transmitcycle);

        //***************************************************************************
        //*     LANIOADRo[^ϊxݒ肵܂
        //*        : handle  LANIOnh
        //*              speed   ϊx
        //*                      0 10sps      1 16.6sps    2 50sps      3 60sps
        //*                      4 400sps     5 1200sps    6 3600sps    7 14400sps
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioSetADCsps")]
        public static extern int SetADCsps(int handle, int speed);

        //***************************************************************************
        //*     LANIOADRo[^ϊx擾܂
        //*        : handle  LANIOnh
        //*              speed   ϊxobt@ւ̃|C^
        //*                      0 10sps      1 16.6sps    2 50sps      3 60sps
        //*                      4 400sps     5 1200sps    6 3600sps    7 14400sps
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetADCsps")]
        public static extern int GetADCsps(int handle, ref int speed);

        //***************************************************************************
        //*     LANIOAI̎]xݒ肵܂
        //*        : handle        LANIOnh
        //*              transmitcycle ]TCNobt@ւ̃|C^ 
        //*                            0:0.05sec  1:0.1sec  2:0.2sec  3:0.5sec
        //*                            4:1sec  5:2sec  6:5sec  7:10sec  8:20sec  9:30sec
        //*                            10:1min  11:2min  12:5min  13:10min
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioSetCyclicTransmit")]
        public static extern int SetCyclicTransmit(int handle, int transmitcycle);

        //***************************************************************************
        //*     LANIOAI̎]Jn܂
        //*        : handle  LANIOnh
        //*              CallBack f[^]R[obN֐
        //*              User     R[obN֐Ă΂Ɏwł郆[Uf[^
        //***************************************************************************
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void CyclicTransmitCallBack(IntPtr user, IntPtr ai);
        [DllImport("LALANIO.dll", EntryPoint = "LALanioStartCyclicTransmit")]
        public static extern int StartCyclicTransmit(int handle, [MarshalAs(UnmanagedType.FunctionPtr)] CyclicTransmitCallBack CallBack, IntPtr User);

        //***************************************************************************
        //*     LANIOAI̎]Jn܂
        //*        : handle  LANIOnh
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioStopCyclicTransmit")]
        public static extern int StopCyclicTransmit(int handle);

        //***************************************************************************
        //*     LANIOLED_臒lݒ肵܂
        //*        : handle  LANIOnh
        //*              ch      `lw肵܂B 0:A*1 1:A*2 ...
        //*              led     0:w肵͈͓LED_ 1:͈͊OLED_
        //*              lthd    臒l
        //*              hthd    臒l
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioSetThreshold")]
        public static extern int SetThreshold(int handle, int ch, int led, int lthd, int hthd);

        //***************************************************************************
        //*     LANIOLED_臒l擾܂
        //*        : handle  LANIOnh
        //*              ch      `lw肵܂B 0:A*1 1:A*2 ...
        //*              led     0:w肵͈͓LED_ 1:͈͊OLED_
        //*              lthd    臒lobt@ւ̃|C^
        //*              hthd    臒lobt@ւ̃|C^
        //***************************************************************************
        [DllImport("LALANIO.dll", EntryPoint = "LALanioGetThreshold")]
        public static extern int GetThreshold(int handle, int ch, ref int led, ref int lthd, ref int hthd);
    }
}